/* Ansteuerung einer 7-Segmentanzeige
 * Gemeinsame Anode, PB0..PB6
 *
 *    a
 *  f   b
 *    g
 *  e   c
 *    d
 *
 */

#include <avr/io.h>
#include <util/delay.h>		// _delay_ms() 

int main (void);

const int8_t numbers [10] =
{
//    1gfedcba
	0b11000000,		// 0
	0b11111001,		// 1
	0b10100100,		// 2
	0b10110000,		// 3
	0b10011001,		// 4
	0b10010010,		// 5
//	0b10000011,		// 6
	0b10000010,		// 6
	0b11111000,		// 7
	0b10000000,		// 8
//	0b10011000,		// 9 
	0b10010000,		// 9
};

// wartet ms Millisekunden
void delay_ms(uint16_t ms)
{
	for(uint16_t t=0; t<=ms; t++)
		_delay_ms(1); 
}

int main ()
{
	int8_t i;
	
	DDRB |= (1 << DDB0) | (1 << DDB1) | (1 << DDB2) | (1 << DDB3) | (1 << DDB4) | (1 << DDB5) | (1 << DDB6);	// PortB als Ausgang
	
	while (1)
	{
		for (i=0; i<=9; i++)
		{
			PORTB = numbers[i];
			delay_ms (800);
		}
	}

	return 0;
}
