/* Ansteuerung einer 16-Segmentanzeige
 * Gemeinsame Kathode, PB0..PB7, PC0..PC7
 *
 */

#include "chars.h"			// Zeichensatz
#include <stdint.h>
#include <avr/io.h>
#include <util/delay.h>		// _delay_ms() 

void delay_ms(uint16_t);
void char_out (uint8_t);
int main (void);

const char text[] = "++ HELLO WORLD! WIE GEHT'S? **" ;

// wartet ms Millisekunden
void delay_ms(uint16_t ms)
{
	for(uint16_t t=0; t<=ms; t++)
		_delay_ms(1); 
}

// Gibt ein Zeichen aus
void char_out (uint8_t zeichen)
{
	PORTB = signs[zeichen-32];
	PORTC = (signs[zeichen-32] >> 8);
}

int main ()
{
	int8_t i;
	
	DDRB = 0xFF;	// PortB komplett als Ausgang
	DDRC = 0xFF;	// PortC komplett als Ausgang

	// Einmal den gesamten Zeichensatz ausgeben
	for (i=0; i<=58; i++)
	{
		PORTB = signs[i];
		PORTC = (signs[i] >> 8);
		delay_ms (800);
	}

	// Einen Buchstaben ausgeben
	char_out ('M');
	delay_ms (5000);

	// Endlos Text ausgeben
	while (1)
	{
		i=0;
		while (text[i]!=0)
		{
			char_out (text[i]);
			delay_ms (700);
			i++;
			PORTB = 0;
			PORTC = 0;
			delay_ms (50);
		}
	}

	return 0;
}
