/* Eingaben ber ein Hyperterminal an die serielle Schnittstelle (Bluetooth) werden als ECHO zurckgesendet
 * 19200Bd, 8N1 wird in uart.c eingestellt
 * Demo fuer Nutzung eines BTM-222 am USART
 * Laesst eine LED x-mal blinken
 * im makefile wird die Compilierung von uart.c angegeben
 */

#include <avr/io.h>
#include <util/delay.h>		// _delay_ms() 
#include "uart.h"

// wartet ms Millisekunden
void delay_ms(uint16_t ms)
{
	for(uint16_t t=0; t<=ms; t++)
		_delay_ms(1); 
}

int main()
{
	unsigned char zeichen;
	int8_t zahl;

	PORTD &= ~(1<<PD6);		// LED an PD6 aus
	DDRD |= (1 << DDD6);		// PD6 als Ausgang

	uart_ini();					// USART einrichten (19200 Bd)

	while (1)					// endlos
	{
		zeichen = ser_getc();					// warte auf Zeichen am USART
		uart_puts ("Sie haben eingegeben: ");	// an USART senden
		uart_putc (zeichen);					// sendet empfangenes Zeichen wieder zurck (ECHO)
		
		zahl = zeichen - 48;					// ASCII Wert des Zeichens in Zahlwert umrechnen
		if ((zahl > 0) && (zahl < 10))
		{
			while (zahl--)						// WHL so oft, wie angegeben wurde
			{
				PORTD |= (1 << PD6);			// LED an PD6 an
				delay_ms (250);
				PORTD &= ~(1 << PD6);			// LED an PD6 aus
				delay_ms (250);
			}
		}
		else
		{
			uart_puts (" - unerlaubter Wert [1-9]");
		}

		uart_puts ("\r\n");						// CR LF
	}
} 

