/* Application Flash
 *
 * 8-Bit Timer 0 im CTC Modus laesst LED2 blinken.
 * Taste2 springt in Bootloader
 *
 */


#include <avr/io.h>
#include <avr/interrupt.h>

#define TEILER 10				// Teilungsverhaeltnis
volatile uint8_t zaehler = TEILER;

// Timer/Counter0 Compare Match
ISR (TIMER0_COMP_vect)
{
	zaehler--;					// Inkrementieren
	if (!zaehler)				// wenn zaehler keinen Wert hat (=0)
	{
		PORTD ^= (1 << PD6);	// PD6 LED2 togglen
		zaehler = TEILER;		// wieder n Schritte
	}
}

int main()
{
	DDRD |= (1 << DDD6);		// PORT D6 (LED2) als Ausgang
	DDRD &= ~(1 << DDD3);		// PD3 als Eingang

	TIMSK |= (1 << OCIE0);		// IRQ bei Compare Match
	OCR0 = 194;					// Vergleichswert einstellen => 40,07 Hz bei Q=16 Mhz
	TCCR0 |= (1 << WGM01);		// CTC-Modus
	TCCR0 |= (1 << CS00) | (1 << CS02);	// Prescaler: 1/1024 (CS1=0 per default)
	sei();						// IRQs enable

	while (1)						// endlos
	{
		if (PIND & (1 << PIND3))	// wenn PD3 geschlossen (HIGH)
			asm("jmp 0x3800");		// Sprung Anfang Flash
	}
	return 0;
}
