// Pinzuordnung. Der Einfachheithalber wird nur ein Port benutzt
#define PORT PORTA
#define PIN PINA
#define DDR DDRA
#define CLK PA0			// SCKL (Clock)
#define DATA PA1		// I/O (Data)
#define CE PA2			// CE (Chip Enable)

// Hilfsmakros fuer Portzustaende 
#define DATA_OUTPUT_MODE() DDR|=(1<<DATA)
#define DATA_INPUT_MODE() DDR&=~(1<<DATA)
#define DATA_LOW() PORT&=~(1<<DATA)
#define DATA_HIGH() PORT|=(1<<DATA)
#define DATA_LEVEL() PIN&(1<<DATA)

#define CLK_OUTPUT_MODE() DDR|=(1<<CLK)
#define CLK_LOW() PORT&=~(1<<CLK)
#define CLK_HIGH() PORT|=(1<<CLK)

#define CE_OUTPUT_MODE() DDR|=(1<<CE)
#define CE_LOW() PORT&=~(1<<CE)
#define CE_HIGH() PORT|=(1<<CE)

// Registeradressen. Alle Werte fuer Schreibzugriffe. Adresse fuer Lesezugriffe (+1) wird berechnet
#define DS1302_SECONDS           0x80
#define DS1302_MINUTES           0x82
#define DS1302_HOURS             0x84
#define DS1302_DATE              0x86
#define DS1302_MONTH             0x88
#define DS1302_DAY               0x8A
#define DS1302_YEAR              0x8C
#define DS1302_ENABLE            0x8E
#define DS1302_TRICKLE           0x90
#define DS1302_CLOCK_BURST       0xBE
#define DS1302_RAMSTART          0xC0
#define DS1302_RAMEND            0xFC
#define DS1302_RAM_BURST         0xFE

typedef struct  // real time clock structure
{
	uint8_t sec;
	uint8_t min;
	uint8_t hour;
	uint8_t date;
	uint8_t month;
	uint8_t year;
	uint8_t dow;
} Trealtime; 

char wochentag[7][11] = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"};
