/* Demonstriert den 8-Bit Timer 0
 *
 * Laesst LED an PDx blinken
 */

#include <avr/io.h>
#include <avr/interrupt.h>

// Timer/Counter0 Overflow 
ISR (TIMER0_OVF_vect)
{
	PORTD ^= (1 << PD5);		// PD5 togglen
	PORTD |= (1 << PD6);		// PD6 ein
}

// Timer/Counter0 Compare Match
ISR (TIMER0_COMP_vect)
{
	PORTD &= ~(1 << PD6);		// PD6 aus
}

int main()
{
	DDRD = 0xFF;		// PORTD als Ausgang
	PORTD = 0;			// alles aus
	
	TIMSK |= (1 << TOIE0) | (1 << OCIE0);	// IRQ bei berlauf + Compare Match
	OCR0 = 0x0A;							// Vergleichswert 10 einstellen
	sei();									// IRQs enable
	TCCR0 |= (1 << CS00) | (1 << CS02);	// Prescaler: 1/1024 (CS1=0 per default)

	while (1);		// endlos
	return 0;
}
